/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

using Gtk;
using Glade;
using System;
using MovieDatabase;
using Util;

class Window_Caching : Util.Windows.PleaseWaitWindow {

    private static readonly string ___Msg = "Updating database cache.";

    // Cache func
    public object AddToCache (Movie _M, object _LastObject)
    {
        // Director 
        if (_M.Data[(int) MovieField.DIRECTOR] != null && _M.Data[(int) MovieField.DIRECTOR] != "") Global.Directors_Cache.AddValue(_M.Data[(int) MovieField.DIRECTOR]);
        
        // Country
        if (_M.Data[(int) MovieField.COUNTRY] != null && _M.Data[(int) MovieField.COUNTRY] != "") Global.Countrys_Cache.AddValue(_M.Data[(int) MovieField.COUNTRY]);

        // Genre
        if (_M.Data[(int) MovieField.GENRE] != null && _M.Data[(int) MovieField.GENRE] != "") Global.Genres_Cache.AddValue(_M.Data[(int) MovieField.GENRE]);

        // VideoFormat
        if (_M.Data[(int) MovieField.VIDEOFORMAT] != null && _M.Data[(int) MovieField.VIDEOFORMAT] != "") Global.VFormats_Cache.AddValue(_M.Data[(int) MovieField.VIDEOFORMAT]);

        // AudioFormat
        if (_M.Data[(int) MovieField.AUDIOFORMAT] != null && _M.Data[(int) MovieField.AUDIOFORMAT] != "") Global.AFormats_Cache.AddValue(_M.Data[(int) MovieField.AUDIOFORMAT]);

        // Release
        if (_M.Data[(int) MovieField.RELEASE] != null && _M.Data[(int) MovieField.RELEASE] != "") Global.Releases_Cache.AddValue(_M.Data[(int) MovieField.RELEASE]);

        // Subtitles
        if (_M.Data[(int) MovieField.SUBTITLES] != null && _M.Data[(int) MovieField.SUBTITLES] != "") Global.Subtitles_Cache.AddValue(_M.Data[(int) MovieField.SUBTITLES]);
        
        return null;
    }

    public Window_Caching() : base(___Msg, false)
    {
        Run();
    }

    public override void Start()
    {
        // Update cache
        ColumnsRequest __CR = new ColumnsRequest();
        __CR.AllColumns();
        MovieDB.ListDatabase(__CR,null,new MovieDB.ListDatabase_ProcessRecord(AddToCache)); 
        
    }

    
}
