/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

using Gtk;
using System;
using Gdk;
using MovieDatabase;

public class FlagFactory
{
    public static Pixbuf[] IconSet;
    
    static FlagFactory() {
        
        int __max = 1;
        foreach (int __Flag in MovieDatabase.MovieFlag.GetValues(typeof (MovieDatabase.MovieFlag))) 
            __max +=  __Flag;

        IconSet = new Pixbuf[__max];

        // Nullify everything
        for (int __i = 0; __i < IconSet.Length; __i++)
            IconSet[__i] = null;

        // Empty pixbuf
        IconSet[0] = new Pixbuf(Colorspace.Rgb, true, 8, 1, 1);
        IconSet[0].Fill(0x00000000);
        

    }

    public static Pixbuf CreateImage(params MovieFlag[] __Flags) 
    {
        
        Pixbuf __PX = new Pixbuf(Colorspace.Rgb, true, 8, __Flags.Length * 17 , 16);
        // Clear it
        __PX.Fill(0xffffff00);
        
        for (int __i = 0; __i < __Flags.Length ; __i++) {
            string __filename = MovieFlag.GetName(typeof (MovieFlag), __Flags[__i]) + ".png";
            // Console.WriteLine(__filename);
            Pixbuf __tmp = new Pixbuf(null, __filename);
            __tmp.CopyArea(0,0,16,16, __PX, __i * 17, 0);
            
            __tmp = null;
            __filename = null;
        }

        return __PX;
    }
    

    public static int CalculateIndex(params MovieFlag[] __Flags) 
    {
        int __sum = 0;
        foreach (MovieFlag __MF in __Flags) {
            __sum += (int) __MF;
        }
        return __sum;
    }


    public static Pixbuf GetPixbufForFlags(params MovieFlag[] __Flags)
    {
        
        int __index = CalculateIndex(__Flags);
        //Console.WriteLine("INDEX: " + __index);
        if (IconSet[__index] == null) IconSet[__index] = CreateImage(__Flags);
        return IconSet[__index];
    }


}
