/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

using Gdk;
using Gtk;
using System;
using Glade;

public class Window_Plugins {

    [Widget] Gtk.Window Window_Plugins_GtkWindow;
    [Widget] Gtk.TreeView Plugins_GtkTreeView;

    public Window_Plugins() 
    {
         Glade.XML gxml = new Glade.XML (null, "PluginsWindow.glade", "Window_Plugins_GtkWindow", null);
         gxml.Autoconnect (this);

         Window_Plugins_GtkWindow.Icon = new Pixbuf(null, "windowicon.png");

         Plugins_GtkTreeView.Model = new Gtk.TreeStore(typeof (string), typeof (string));
         Plugins_GtkTreeView.AppendColumn ("Plugin", new CellRendererText (), "text", 0);
         Plugins_GtkTreeView.AppendColumn ("Author", new CellRendererText (), "text", 1);
         
         // FIXME: Need to base all this window on listwindow
                  
         // Add import plugins
         foreach (PluginLib.Plugin __Plugin in PluginManager.ImportPlugins) {
             TreeIter __lastrow = ((Gtk.TreeStore)Plugins_GtkTreeView.Model).AppendValues();
             ((Gtk.TreeStore)Plugins_GtkTreeView.Model).SetValue(__lastrow, 0, __Plugin.GetName());
             ((Gtk.TreeStore)Plugins_GtkTreeView.Model).SetValue(__lastrow, 1, __Plugin.GetAuthor());
         }

         // Add export plugins
         foreach (PluginLib.Plugin __Plugin in PluginManager.ExportPlugins) {
             TreeIter __lastrow = ((Gtk.TreeStore)Plugins_GtkTreeView.Model).AppendValues();
             ((Gtk.TreeStore)Plugins_GtkTreeView.Model).SetValue(__lastrow, 0, __Plugin.GetName());
             ((Gtk.TreeStore)Plugins_GtkTreeView.Model).SetValue(__lastrow, 1, __Plugin.GetAuthor());
         }
         
         // Add getfrom plugins
         foreach (PluginLib.Plugin __Plugin in PluginManager.GetFromPlugins) {
             TreeIter __lastrow = ((Gtk.TreeStore)Plugins_GtkTreeView.Model).AppendValues();
             ((Gtk.TreeStore)Plugins_GtkTreeView.Model).SetValue(__lastrow, 0, __Plugin.GetName());
             ((Gtk.TreeStore)Plugins_GtkTreeView.Model).SetValue(__lastrow, 1, __Plugin.GetAuthor());
         }


         


         Window_Plugins_GtkWindow.ShowAll();

          Application.Run();
    }
    
    public void On_WindowDelete (object o, DeleteEventArgs args) 
    {
        Window_Plugins_GtkWindow.Destroy();
        Application.Quit ();
    }
    
    public void On_OK (object o, EventArgs args)
    {
        On_WindowDelete(null, null);
    }

    

}
