/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

using System;
using Gtk;
using Gdk;
using Util;

public class StockIcons {

    public static IconFactory Factory = new IconFactory();
    
    private static string[] IconThemeIcons = {
        "gnome-dev-cdrom", 
        "gnome-dev-dvd", 
        "gnome-empty" };
    

    /* Constructor */
    public static void Init()
    {
        Debug.Message("Monotheka.exe", "StockIcons", "Initializing");
        Factory.AddDefault();

        // Gnome Icon Theme
        foreach (string __Name in IconThemeIcons) {

            // FIXME: We need to fetch the icons from Gnome Icon Theme,
            // but it looks like not possible in GTK# 1
            Debug.Message ("Monotheka.exe", "StockIcons", String.Format("Loading {0} icon", __Name));    
            Pixbuf __Pixbuf = new Pixbuf (null, __Name + ".png");
            IconSet __IconSet = new IconSet (__Pixbuf);
            
            Factory.Add (__Name, __IconSet);

            // GTK# 2.0 compatible:
            /*IconSet iconset = new IconSet ();
            IconSource iconsource = new IconSource ();
            iconsource.IconName = __Name;
            iconset.AddSource (iconsource);
            Factory.Add (__Name, iconset);*/
        }

    }


}
