/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* HTML snippet is a small piece of HTML with replacable parts
 */

using System;

public class HTMLSnippet {

    public string HTML;


    /* Constructor */
    public HTMLSnippet(string _HTML)
    {
        HTML = _HTML;
    }


    public void Debug(string _SnippetName)
    {
        Console.WriteLine("{0} snippet is: \n{1}", _SnippetName, HTML);
    }
    
}


public class HTMLSnippetParser {

    private string Data;

    /* Constructor */
    public HTMLSnippetParser(HTMLSnippet _Snippet)
    {
        Data = _Snippet.HTML;
    }


    /* Replace template value with a real value*/
    public void Parse(string _TemplateString, string _Value)
    {
        // FIXME: Do we really need that?
        if (_TemplateString == _Value) throw new Exception("Both strings are equal! Replacing would cause a dead-loop");

        Data = Data.Replace(_TemplateString, _Value);
    }


    /* Get the actual string */
    public string GetParsedHTML()
    {
        return Data;
    }
    
}
    

