/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

using System;
using MovieDatabase;
using System.IO;

public class TextWriter {

    private StreamWriter Writer;

    static string Str_Error1 = "Specified file could not be opened for writing!";

    public TextWriter(string _Filename)
    {
        Writer = null;
                
        try {
            Writer = new StreamWriter(_Filename);
        }
        catch (Exception excp) { 
            throw new Exception (Str_Error1, excp);
        }

        // Write the header
        DBInfo __Info = MovieDB.GetDBInfo();
        string __Header = Util.Strings.MakeTitle(__Info.Name, 73, true) + "\n" + Util.Strings.MakeTitle(__Info.Owner + " <" + __Info.Contact + ">", 73, false) + "\n\n" + __Info.Comment + "\n\n" ;
        Writer.Write(__Header);
        

    }

    public object WriteMovie(Movie _M, object _Object)
    {
        string __No = " " + _M.Data[(int)MovieField.NO].PadRight(3) + " |"; // 6
        string __Title;
        if (_M.Data[(int)MovieField.TITLE].Length <= 27) __Title = " " + _M.Data[(int)MovieField.TITLE].PadRight(30) + " |"; // 38
        else __Title = " " + _M.Data[(int)MovieField.TITLE].Substring(0, 27) + "..." + " |"; // 38
        
        string __Director;
        if (_M.Data[(int)MovieField.DIRECTOR].Length <= 17) __Director = " " + _M.Data[(int)MovieField.DIRECTOR].PadRight(20) + " |"; // 26
        else __Director = " " + _M.Data[(int)MovieField.DIRECTOR].Substring(0, 17) + "..." + " |"; // 26

        string __Subs;
        if (_M.Data[(int)MovieField.SUBTITLES].Length <= 10) __Subs = " " + _M.Data[(int)MovieField.SUBTITLES].PadRight(10) ; // 12
        else __Subs = " " + _M.Data[(int)MovieField.SUBTITLES].Substring(0, 10); // 12

        

        string __Line = __No + __Title + __Director + __Subs + "\n";
        Writer.Write(__Line);
        return null;
    }

    
    /* Closes file */
    public void CloseFile() {

        // Write footer
        Writer.Write("\n" + ("[" + DateTime.Now.ToShortDateString() + "]").PadLeft(73) + "\n");

        // Close file
        if (Writer != null) Writer.Close();
        Writer = null;
    }

    /* Destructor */
    ~TextWriter() {
        CloseFile();
    }
    


}
