/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* REV: MDK
 * DESCRIPTION: A common set of debug functions
 */

using System;



namespace Util {
    
    
    public class Debug {
 
        private static bool Enabled = false;
  
        //////////////////////////////////////////////////

        /* Enable DEBUG */
        public static void TurnOn()
        {
            Enabled = true;
        }
        
        
        /* Spit out a message */
        public static void Message (string _Module, string _Class, string _Message)
        {
            if (Enabled) Console.WriteLine("{0} | {1} | {2} " , _Module.PadRight(20,' '), _Class.PadRight(25,' '), _Message);
            
        }
        
        
        /* Spit out an Exception */
        public static void Exception (string _Module, string _Class, Exception _Excp)
        {   
            if (Enabled) Console.WriteLine("{0} | {1} | EXCEPTION! ({2}) \n\nStackTrace: {3}\n" , _Module.PadRight(20,' '), _Class.PadRight(25,' '), _Excp.Message, _Excp.StackTrace);
        }
        
    }

}
