/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

using System;
using GConf;

namespace Util {

    public class GConfRegistry {
        
        private static GConf.Client GConf_Client;
        

        /* Constructor */
        static GConfRegistry()
        {
            GConf_Client = new GConf.Client();
        }

        /* Get a key value or a default value */
        public static object Get (string _Key, object _Default)
        {
            
            try {
                return GConf_Client.Get (_Key);
            } catch {
                return _Default;
            }
        }
        
        
        /* Set a key in gconf */
        public static void Set (string _Key, object _Val)
        {
            GConf_Client.Set (_Key, _Val);
        }

        
        public static void AddNotify(string _Key, NotifyEventHandler _NotifyFunc)
        {
            Debug.Message("Util.dll", "GConfRegistry", String.Format("Adding notify function for key {0}", _Key));
            GConf_Client.AddNotify(_Key, _NotifyFunc);
        }
        
    }

}
